% -*- mode: slang_mode; mode: fold; -*-
% sltabc.sl ks 2002-05-30
% Notes                                                                %{{{
%_debug_info=1;
%_traceback=1;
%_slangtrace=1;
#iffalse
% Example to implement in jed.rc or .jedrc

variable SLTABC= path_concat( Jed_Home_Directory, "patchlib");

autoload( "sltabc", path_concat( SLTABC, "sltabc.sl"));
autoload( "sltabc_evaluate_cmd", path_concat( SLTABC, "sltabc.sl"));

loop ( which_key( "evaluate_cmd"))
{ 
%   "sltabc_evaluate_cmd"; exch(); setkey();
pop();
}
   "sltabc_evaluate_cmd"; ""; setkey();
}

define global_mode_hook (hook_name)
{
   if ( hook_name == "slang_mode_hook")
     {
        set_buffer_hook( "indent_hook", "sltabc");
     }
}
#endif
%}}}
require( "cmode.sl");
static variable Popup= "*sl-Completions*";
static variable sltabc_minihelp= "*sl-Completions*";

static variable intf=[  % 65 internal functions                        %{{{
                      "backward_delete_char",
                      "backward_delete_char_untabify",
                      "beep",
                      "beg_of_buffer",
                      "beg_of_line",
                      "begin_macro",
                      "center_line",
                      "copy_region",
                      "delete_char_cmd",
                      "delete_window",
                      "digit_arg",
                      "end_macro",
                      "end_of_buffer",
                      "enlarge_window",
                      "eol_cmd",
                      "evaluate_cmd",
                      "exchange",
                      "execute_macro",
                      "exit_jed",
                      "exit_mini",
                      "find_file",
                      "format_paragraph",
                      "goto_match",
                      "indent_line",
                      "insert_file",
                      "kbd_quit",
                      "kill_buffer",
                      "kill_line",
                      "kill_region",
                      "macro_query",
                      "mark_spot",
                      "mini_complete",
                      "mouse_cmd",
                      "narrow",
                      "narrow_paragraph",
                      "narrow_to_region",
                      "newline",
                      "newline_and_indent",
                      "next_char_cmd",
                      "next_line_cmd",
                      "one_window",
                      "other_window",
                      "page_down",
                      "page_up",
                      "pop_spot",
                      "previous_char_cmd",
                      "previous_line_cmd",
                      "quoted_insert",
                      "redraw",
                      "save_some_buffers",
                      "scroll_left",
                      "scroll_right",
                      "select_menubar",
                      "self_insert_cmd",
                      "set_mark_cmd",
                      "split_window",
                      "switch_to_buffer",
                      "sys_spawn_cmd",
                      "text_smart_quote",
                      "trim_whitespace",
                      "undo",
                      "widen",
                      "widen_region",
                      "write_buffer",
                      "yank"];
%}}}   
static variable keyw=[  % 49 reserved keywords                         %{{{
                      "ERROR_BLOCK",         % !if not used here
                      "EXECUTE_ERROR_BLOCK", % from syntax table
                      "EXIT_BLOCK",
                      "NULL",                % from syntax table
                      "USER_BLOCK0",
                      "USER_BLOCK1",
                      "USER_BLOCK2",
                      "USER_BLOCK3",
                      "USER_BLOCK4",
                      "__tmp",
                      "_for",
                      "abs",
                      "and",
                      "andelse",
                      "break",
                      "case",
                      "chs",
                      "continue",
                      "define",
                      "do",
                      "do_while",
                      "else",
                      "exch",
                      "for",
                      "foreach",
                      "forever",
                      "if",
                      "loop",
                      "mod",
                      "mul2",
                      "not",
                      "or",
                      "orelse",
                      "pop",
                      "private",
                      "public",
                      "return",
                      "shl",
                      "shr",
                      "sign",
                      "sqr",
                      "static",
                      "struct",
                      "switch",
                      "typedef",
                      "using",
                      "variable",
                      "while",                      
                      "xor"];
%}}}

static define subarray_by_re( a, r) % get subarray by regexp           %{{{
{
   variable x=Integer_Type[length(a)], i;
   
   for (i=0;i<length( a);i++)
     x[i]= string_match( a[i], r, 1);

   return a[where (x)];
}
%}}}
static define possible_words( w) % returns array of possible words     %{{{
{
   variable n, n1, n2, n3, a1, a2, a3;

   a1= _apropos( "Global", "^"+w, 0xF);
   a2= subarray_by_re( intf, "^"+w);
   a3= subarray_by_re( keyw, "^"+w);

   n1= length( a1);
   n2= length( a2);
   n3= length( a3);
   
   variable a= String_Type[n1+n2+n3];
   if ( n1) a[[:n1-1]]= a1;
   if ( n2) a[[n1:n1+n2-1]]= a2;
   if ( n3) a[[n1+n2:]]= a3;

   return a[array_sort(a)];;
}
%}}}

static define goto_popup() %                                           %{{{
{
%  provides a visible buffer %{{{
%  does not change current window
%  saves data to restore covered
%  or splitted window in blocal variables
% Now we are in the (normal) current window
% If we have 2 or more normal windows, we go to the next.
% (Thus the current remains visible.)

% popup if we have just 1 normal window

% NB: If mini is active, it increases nwindows by one.
%     Mini inserts itself BEFORE the current window.
%     Native window order is from top to bottom.
%}}}

   variable b, na, nn, v, nr, w_b, w_i;

   b= whatbuf();
   na= nwindows();                     % number of active windows
   nn= na -MINIBUFFER_ACTIVE; % number of normal windows

   v= buffer_visible( Popup);
   nr= na;
   loop ( na)
     {
        otherwindow();
        nr--;
        if ( whatbuf() == Popup) return nr;
        if ( v) continue;
        !if (andelse{ MINIBUFFER_ACTIVE}{ whatbuf() == " <mini>"}) break;
     }

   w_b= whatbuf();
   w_i= [ 0, what_line(), _get_point(), window_line()];
   if ( nn == 1)
     {
        w_i[0]= 1;
        splitwindow();
        otherwindow();
        nr= 1;
        if ( MINIBUFFER_ACTIVE)
          {
             if ( whatbuf() == " <mini>")
               {
                  otherwindow();
                  if ( b == " <mini>") nr= 2;
               }
             else
               {
                  if ( b != " <mini>") nr= 2;
               }
          }
     }

   sw2buf( Popup);
   create_blocal_var( "w_b");
   create_blocal_var( "w_i");
   set_blocal_var( w_b, "w_b");
   set_blocal_var( w_i, "w_i");
   return nr;
}
%}}}
static define remove_popup() %                                         %{{{
{
   variable b, na, nn, w_b, w_i;
   
   b= whatbuf();
   na= nwindows();                     % number of active windows
   nn= na -MINIBUFFER_ACTIVE; % number of normal windows

   loop ( na)
     {
        otherwindow();
        if ( whatbuf() != Popup) continue;
        !if (andelse{ blocal_var_exists( "w_b")}
              {blocal_var_exists( "w_i")}) continue;
        w_b= get_blocal_var( "w_b");
        w_i= get_blocal_var( "w_i");

        if (andelse{ w_i[0]}{ nn == 2})
          {
             otherwindow();
             if (andelse{ MINIBUFFER_ACTIVE}{ whatbuf() == " <mini>"})
               otherwindow();
             onewindow();
             if (andelse{ whatbuf() == w_b}{ what_line() == w_i[1]})
               recenter( w_i[3]);
             if ( b == " <mini>") otherwindow();
             break;
          }

        sw2buf( w_b);
        goto_line( w_i[1]);
        _set_point( w_i[2]);
        recenter( w_i[3]);
     }
   if ( bufferp( Popup)) delbuf( Popup);
}
%}}}

static define expand_word( w, a) %                                     %{{{
% General function for tab completion and similar.
% w: word to complete (string)
% a: possible words (string array)
% x: expansion of word (return value, string)

% NB: all possible words have to start with w
{
   variable x, m, i, k, n;

   if (not length(a)) return "";

%-- minimum strlen of all a[i]'s
   m= strlen(a[0]);
   for ( i= 1; i < length( a); i++)
     if ( n= strlen( a[i]), n < m) m= n;

%-- NB: w+x is the greatest common initial
%-- substring of all a[i]'s
   x= "";
   for ( n= strlen( w); n < m; n++)
     {
        k= a[0][[n:n]];
        for ( i =1; i < length(a); i++)
          if ( a[i][[n:n]] != k) return x;
        x+= k;
     }
   return x;
}
%}}}
static define tab_action( r) %                                         %{{{
{
   variable i, k, cw= "a-zA-Z0-9_";
     
   i= _get_point();
   if ( what_keymap() != "Mini_Map")
     {
        %-- do c_indent_line() and see what happens
        k= what_char();
        c_indent_line();
        if (orelse{ _get_point() != i}{ what_char() != k}) return 1;
     }

   bskip_chars( cw);
   push_mark();
   skip_chars( cw);
   @r= bufsubstr();

   if ( _get_point() != i) return 1;
   if ( @r == "")
     {
        if (andelse{ what_keymap() == "Mini_Map"}{ eolp()}) return 0;
        skip_chars( "^"+cw);
        skip_chars( cw);
        return 1;
     }
   return 0;
}
%}}}

static define minihelp_text( w) %                                      %{{{
{
   variable t, i, f;
   
   f= path_concat( SLTABC, "minihelp.dat");
   t= get_doc_string_from_file( f, w);
   if ( t == NULL) return t;

   t= strtrim( t);  % remove newline
   (t,)= strreplace( t, w, "", 1);
   (t,)= strreplace( t, "~", w, 1);
   (t,)= strreplace( t, "--", "", 1);
   for (i=strlen(t)-1;i;i--) if (t[i]==' ') break;
   return substr( t, 1, i);
}
%}}}
static define auto_comment( w, i) %                                    %{{{
{
   variable t= ["Library/User Variable",
                "Intrinsic/Jed Variable",
                "",
                "Intrinsic/Jed Function",
                "Library/User Function"];

   if ( i)
     {
        if ( is_internal( w)) return "Internal Function";
        return "???";
     }
   if ( i= is_defined( w), i) return t[i+2];
   return "Reserved Keyword";
}
%}}}
static define insert_matches( w, a) %                                  %{{{
{
   variable i, t, m, n, s;

   for (i=0;i<length(a);i++)
     {
        if ( a[i] == w)
          {
             if (not i) t= minihelp_text( w); else t= NULL;
             if ( t == NULL)
               a[i]= "     " +w;
             else
               {
                  m= is_substr( t, w);
                  s= strtrim( substr( t, 1, m-1))+" ";
                  n= strlen( s);
                  loop ( 5 -n) s= " "+s;
                  a[i]= s +substr( t, m, -1) +"\n     ";
                  loop ( strlen( w)) a[i]+= " ";
               }
             a[i]+= "  "+auto_comment( w, i);
          }
        else
          {
             if (orelse{ i == 0}{ i == length(a)-1}) %
               t= ">>>  ";
             else
               t= "     ";
             a[i]= t +a[i];
          }
     }
   insert( strjoin( a, "\n"));
}
%}}}
static define show_no_match( w) %                                      %{{{
{
   variable nr;
   
   nr= goto_popup();
   erase_buffer();
   set_status_line( "(Jed %v) Tab: %b %l/%L",0);
   insert( w +"  no match found");

   set_column_colors( color_number( "error"), 1, 80);
   set_column_colors( color_number( "comment"), 1, strlen(w));
   set_buffer_modified_flag( 0);
   loop ( nr) otherwindow();
}
%}}}
static define show_matches( w, a) %                                    %{{{
{
   variable nr, i;
   
   nr= goto_popup();
   erase_buffer();

   insert_matches( w, a);
   bob();
   
   set_column_colors( color_number( "message"), 1, 80);
   set_column_colors( color_number( "comment"), 6, 5+strlen(w));
   set_buffer_modified_flag( 0);

   set_status_line( "(Jed %v) PageDown/PageUp/Tab: %b %l/%L",0);

   loop ( nr) otherwindow();
}
%}}}

% slang prompt
static variable e_f;
static define set_keys_mini( j) %                                      %{{{
{
   variable f, s;
   variable mini = "Mini_Map";

   if ( j)
     {
        definekey( "sltabc_mini_complete", "\t", mini);
        definekey( "sltabc_exit_minibuffer", "\r",  mini);
     }
   else
     {
        definekey ("mini_complete", "\t", mini);
        definekey ("mini_exit_minibuffer", "\r", mini);
     }

   foreach ([ "page_down", "page_up"])
     {
        f= ();
        s= "sltabc_" +f;
        if ( j)
          loop ( which_key( f)) { s; exch(); mini; definekey();}
        else
          loop ( which_key( s)) { f; exch(); mini; definekey();}
     }

}
%}}}
public define sltabc_mini_complete() %                                 %{{{
{
   variable i, w, a, b, x, s;

   if ( tab_action( &w))
     {
        if ( buffer_visible( Popup)) remove_popup();
        return;
     }

   a= possible_words( w);
   x= expand_word( w, a);

   switch(NULL)
     {andelse{ x == ""}
          { LAST_KBD_COMMAND == _function_name()}
          { buffer_visible( Popup)}:
        remove_popup();
     }
     {not length(a):
        show_no_match( w);
     }
     {
        insert( x);
        w+= x;
        show_matches( w, a);
     }
   
}
%}}}
public define sltabc_exit_minibuffer() %                               %{{{
{
   variable b;

   eob();
   e_f= 0;
   while ( andelse{ left(1)}{ what_char() == '='}{ e_f < 2})
     {
        e_f++;
        del();
     }

   set_keys_mini( 0);
   remove_popup();
   mini_exit_minibuffer();
}
%}}}
public define sltabc_evaluate_cmd() %                                  %{{{
{
   variable s;
   
   set_keys_mini( 1);
   ERROR_BLOCK
     {
        _clear_error();
        set_keys_mini( 0);
        remove_popup();
        return;
     }
   call( "evaluate_cmd");
   
   switch ( e_f)
     {  case 1: string(); message();}
     {  case 2:
        _stk_reverse( _stkdepth);
        s= "";
        while ( _stkdepth) s+= string()+";";
        message( s);
     }
}
%}}}

% slang buffer
static define set_keys( j) %                                           %{{{
{
   variable f, s;

   foreach ([ "page_down", "page_up"])
     {
        f= ();
        s= "sltabc_" +f;
        if ( j)
          loop ( which_key( f)) { s; exch(); local_setkey();}
        else
          loop ( which_key( s)) { f; exch(); local_setkey();}
     }
}
%}}} insert
public define sltabc() %                                               %{{{
{
   variable i, k, w, a, b, x, s, n;

   if ( tab_action( &w))
     {
        if ( buffer_visible( Popup))
          {
             remove_popup();
             set_keys( 0);
          }
        return;
     }
   
   a= possible_words( w);
   x= expand_word( w, a);

   switch(NULL)
     {andelse{ x == ""}
          { LAST_KBD_COMMAND == "\t"}
          { buffer_visible( Popup)}:
        remove_popup();
        set_keys( 0);
     }
     {not length(a):
        show_no_match( w);
        set_keys( 1);
     }
     {
        insert( x);
        w+= x;
        show_matches( w, a);
        set_keys( 1);
     }

}
%}}}

% all
public define sltabc_page_down() %                                     %{{{
{
   variable nr, j, i, k, n;
   variable f= "page_down";

   k= ( what_keymap() != "Mini_Map");
   if (andelse{ k}{ not buffer_visible( Popup)})
     {
        set_keys( 0);
        call( f);
        return;
     }
   
   nr= goto_popup();
   if ( j= eobp(), not j)
     {
        call( "page_down");
        n= window_info( 'r');
        ()= down( n -window_line());
        eol();
        recenter( n);
     }
   loop ( nr) otherwindow();
   
   if (andelse{ k}{ j})
     {
        remove_popup();
        set_keys( 0);
     }
}
%}}}
public define sltabc_page_up() %                                       %{{{
{
   variable nr, j, i, k;
   variable f= "page_up";

   k= ( what_keymap() != "Mini_Map");
   if (andelse{ k}{ not buffer_visible( Popup)})
     {
        set_keys( 0);
        call( f);
        return;
     }
   
   nr= goto_popup();
   if ( j= bobp(), not j)
     {
        call( f);
        ()= up( window_line() -1);
        recenter( 1);
     }
   loop ( nr) otherwindow();
   
   if (andelse{ k}{ j})
     {
        remove_popup();
        set_keys( 0);
     }
}
                                 
%}}}
